Controllers/New/RAllUsersController.cs
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Net;
using System.Net.Mail;
using System.Security.Cryptography;
using System.Text;
using System.Threading.Tasks;
using System.Web;
using System.Web.Mvc;
using LabMaintanance6.Models;

namespace LabMaintanance6.Controllers.New
{
    public class RAllUsersController : Controller
    {
        private LabMaintanance4Entities db = new LabMaintanance4Entities();

        // GET: RAllUsers
        public ActionResult Index()
        {
            string userEmail = Session["UserEmail"] as string;
            var allUsers = db.AllUsers.Where(u => u.email == userEmail);
            if (allUsers != null)
            {
                return View(allUsers.ToList());
            }
            else
            {
                return View("Error", "Home");
            }
        }

        public async Task<ActionResult> SendEmail(string email, string subject, string body)
        {
            try
            {
                var smtpClient = new SmtpClient("smtp.gmail.com")
                {
                    Port = 587,
                    Credentials = new NetworkCredential("soumaykanti2859@gmail.com", "ssatuysevdkgrthi"),
                    EnableSsl = true
                };

                using (var message = new MailMessage("soumaykanti2859@gmail.com", email)
                {
                    Subject = subject,
                    Body = body,
                    IsBodyHtml = true
                })
                {
                    await smtpClient.SendMailAsync(message);
                }

                return RedirectToAction("Index");
            }
            catch (Exception ex)
            {
                // Handle exception and display appropriate error message
                ModelState.AddModelError($"{ex}", "Failed to send email. Please try again later.");
                return RedirectToAction("Index");
            }
        }



        public async Task<ActionResult> VerifyEmail(int? id)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }

            AllUser allUser = db.AllUsers.Find(id);
            if (allUser == null)
            {
                return HttpNotFound();
            }

            // Generate and send a new verification OTP to the user's email
            int verificationOTP = GenerateOTP(); // Replace this with your logic to generate the OTP
            string emailBody = $"Your verification OTP is: {verificationOTP}";
            await SendEmail(allUser.email, "Email Verification OTP", emailBody);

            // Save the OTP and the registered email in the session for verification
            Session["EmailVerificationOTP"] = verificationOTP;
            Session["RegisteredEmail"] = allUser.email;

            return View();
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult VerifyEmail(string otp)
        {
            var enteredOTP = int.Parse(otp);
            var savedOTP = (int)Session["EmailVerificationOTP"];
            if (enteredOTP == savedOTP)
            {
                var email = Session["RegisteredEmail"].ToString();

                var user = db.AllUsers.SingleOrDefault(u => u.email == email);
                if (user != null)
                {
                    user.status = true;
                    user.email_verified = true;
                    db.Entry(user).State = EntityState.Modified;
                    db.SaveChanges();
                }

                TempData["SuccessMessage"] = "Email verified successfully!";
                return RedirectToAction("Login","Home", new { id = user.user_id });
            }

            ModelState.AddModelError("", "Invalid OTP. Please try again.");
            return View();
        }

        // Helper method to generate a random 6-digit OTP (you can implement your own logic here)
        private int GenerateOTP()
        {
            Random random = new Random();
            return random.Next(100000, 999999);
        }



        public ActionResult StoreEmailInSession()
        {
            return View();
        }

        [HttpPost]
        public ActionResult StoreEmailInSession(string email)
        {
            // Check if the email is not empty (you can add further validation if needed)
            if (!string.IsNullOrEmpty(email))
            {
                // Store the email in the session
                Session["UserEmail"] = email;
                return RedirectToAction("Index", "DAllUsers");
            }

            // Redirect back to the Getsession action
            return RedirectToAction("Getsession");
        }

       
        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                db.Dispose();
            }
            base.Dispose(disposing);
        }
    }
}

Controllers/Stuff/Stufftech2Controller.cs
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Net;
using System.Net.Mail;
using System.Web;
using System.Web.Mvc;
using LabMaintanance6.Models;
using PagedList;
using PagedList.Mvc;

namespace LabMaintanance6.Controllers.Stuff
{
    public class Stufftech2Controller : Controller
    {
        private LabMaintanance4Entities db = new LabMaintanance4Entities();

        // GET: Stufftech2
        public ActionResult Index(int? i)
        {
            // Retrieve user ID from session
            int? userId = Session["UserId"] as int?;
            // Retrieve role ID from session
            int? roleId = Session["RoleId"] as int?;

            // Perform authorization logic using the session's UserId and RoleId
            if (userId == null || roleId != 2)
            {
                // Authorization failed, redirect to Home/Index
                return RedirectToAction("Index", "Home");
            }
            var tech2 = db.tech2.Include(t => t.Complain)
                                .Where(t => t.status == true)
                                .ToList()
                                .OrderByDescending(c => c.action_id) // Order by a specific property, such as Id
                .ToList()
                .ToPagedList(i ?? 1, 3);


            return View(tech2);
        }

      

        // GET: Stufftech2/Create
        public ActionResult Create()
        {
            // Retrieve user ID from session
            int? userId = Session["UserId"] as int?;
            // Retrieve role ID from session
            int? roleId = Session["RoleId"] as int?;

            // Perform authorization logic using the session's UserId and RoleId
            if (userId == null || roleId != 2)
            {
                // Authorization failed, redirect to Home/Index
                return RedirectToAction("Index", "Home");
            }
            var activeComplains = db.Complains.Where(c => c.status == true);
            ViewBag.complain_id = new SelectList(activeComplains, "complain_id", "Name_Of_the_Item");
            return View();
        }

        // POST: Stufftech2/Create
        // To protect from overposting attacks, enable the specific properties you want to bind to, for 
        // more details see https://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Create([Bind(Include = "action_id,complain_id,technicianName,action_description,action_date")] tech2 tech2, int id)
        {
            // Retrieve user ID from session
            int? userId = Session["UserId"] as int?;
            // Retrieve role ID from session
            int? roleId = Session["RoleId"] as int?;

            // Perform authorization logic using the session's UserId and RoleId
            if (userId == null || roleId != 2)
            {
                // Authorization failed, redirect to Home/Index
                return RedirectToAction("Index", "Home");
            }
            if (ModelState.IsValid)
            {
                tech2.status = true;
                tech2.complain_id = id;
                db.tech2.Add(tech2);
                // Get the list of users with role_id = 2
                var users = db.AllUsers.Where(u => u.role_id == 1 && u.status == true).ToList();

                // Send email to each user
                try
                {
                    foreach (var user in users)
                    {
                        SendEmail(user.email, "Lab Maintanior", "A new Action has been taken. Please review it.");
                    }
                }
                catch (Exception ex)
                {
                    // Log the exception for debugging purposes
                    System.Diagnostics.Debug.WriteLine($"Exception: {ex}");

                    ViewBag.ErrorMessage = "An error occurred while processing your request.";

                    // In this example, we're just continuing the process even if an exception occurs
                }

                db.SaveChanges();
                return RedirectToAction("Index");
            }

            ViewBag.complain_id = new SelectList(db.Complains, "complain_id", "Name_Of_the_Item", tech2.complain_id);
            return View(tech2);
        }
        private void SendEmail(string recipient, string subject, string body)
        {
            // Configure the SMTP client
            var smtpClient = new SmtpClient("smtp.gmail.com", 587);
            smtpClient.EnableSsl = true;
            smtpClient.UseDefaultCredentials = false;
            smtpClient.Credentials = new NetworkCredential("soumaykanti2859@gmail.com", "ssatuysevdkgrthi");

            // Create the email message
            var message = new MailMessage();
            message.From = new MailAddress("soumaykanti2859@gmail.com");
            message.To.Add(new MailAddress(recipient));
            message.Subject = subject;
            message.Body = body;

            // Send the email
            smtpClient.Send(message);
        }
        public ActionResult Delete(int? id)
        {
            // Retrieve user ID from session
            int? userId = Session["UserId"] as int?;
            // Retrieve role ID from session
            int? roleId = Session["RoleId"] as int?;

            // Perform authorization logic using the session's UserId and RoleId
            if (userId == null || roleId != 2)
            {
                // Authorization failed, redirect to Home/Index
                return RedirectToAction("Index", "Home");
            }
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            tech2 tech2 = db.tech2.Find(id);
            if (tech2 == null)
            {
                return HttpNotFound();
            }
            return View(tech2);
        }

        // POST: tech2/Delete/5
        [HttpPost, ActionName("Delete")]
        [ValidateAntiForgeryToken]
        public ActionResult DeleteConfirmed(int id)
        {
            // Retrieve user ID from session
            int? userId = Session["UserId"] as int?;
            // Retrieve role ID from session
            int? roleId = Session["RoleId"] as int?;

            // Perform authorization logic using the session's UserId and RoleId
            if (userId == null || roleId != 2)
            {
                // Authorization failed, redirect to Home/Index
                return RedirectToAction("Index", "Home");
            }
            tech2 tech2 = db.tech2.Find(id);
            tech2.status = false;
            db.Entry(tech2).State = EntityState.Modified;
            db.SaveChanges();
            return RedirectToAction("Index");
        }


        protected override void Dispose(bool disposing)
        {

            if (disposing)
            {
                db.Dispose();
            }
            base.Dispose(disposing);
        }
    }
}

Views/Shared/GeneralLayout.cshtml
<!DOCTYPE html>
<html>
<head>
    @RenderSection("Styles", required: false)
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>@ViewBag.Title - Lab Maintainer</title>
    @Styles.Render("~/Content/css")
    @Scripts.Render("~/bundles/modernizr")
    @Styles.Render("~/Content/bootstrap-css") <!-- Include Bootstrap CSS -->
    <style>
        .navbar-nav.ml-auto {
            margin-left: auto;
        }
    </style>
</head>
<body>
    <nav class="navbar navbar-expand-lg navbar-light bg-light">
        <div class="container-fluid">
            <a class="navbar-brand" href="#">Lab Maintainer</a>
            <button class="navbar-toggler ml-auto" type="button" data-bs-toggle="collapse" data-bs-target="#navbarColor03" aria-controls="navbarColor03" aria-expanded="false" aria-label="Toggle navigation">
                <span class="navbar-toggler-icon"></span>
            </button>
            <div class="collapse navbar-collapse" id="navbarColor03">
                <ul class="navbar-nav ml-auto">
                    <li class="nav-item">
                        <a class="nav-link" href="@Url.Action("Login", "Home")">Login</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="@Url.Action("Register", "Home")">Register</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="@Url.Action("StoreEmailInSession", "DAllUsers")">Forget Password</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="@Url.Action("StoreEmailInSession", "RAllUsers")">Account Activation & Revarify </a>
                    </li>

                </ul>
            </div>
        </div>

    </nav>

    <div class="container mt-4 mb-5">
        @RenderBody()
    </div>

    <footer class="footer fixed-bottom bg-light py-2">
        <div class="container">
            <p class="m-0 text-center">© 2023 Lab Maintenance Website. All Rights Reserved by Group 9.</p>
        </div>
    </footer>

    @Scripts.Render("~/bundles/jquery")
    @Scripts.Render("~/bundles/bootstrap-js") <!-- Include Bootstrap JavaScript -->
    <script>
        $(document).ready(function () {
            $('.navbar-toggler').click(function () {
                $('.navbar-collapse').toggleClass('show');
            });
        });
    </script>
    @RenderSection("scripts", required: false)
</body>
</html>

Views/Shared/User_layout.cshtml
<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>@ViewBag.Title - Lab Maintainer</title>
    @Styles.Render("~/Content/css")
    @Scripts.Render("~/bundles/modernizr")
    @Styles.Render("~/Content/bootstrap-css") <!-- Include Bootstrap CSS -->
    <style>
        .navbar-nav.ml-auto {
            margin-left: auto;
        }
    </style>
</head>
<body>
    <nav class="navbar navbar-expand-lg navbar-light bg-light">
        <div class="container-fluid">
            <a class="navbar-brand" href="#">Lab Maintainer</a>
            <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarColor03" aria-controls="navbarColor03" aria-expanded="false" aria-label="Toggle navigation">
                <span class="navbar-toggler-icon"></span>
            </button>
            <div class="collapse navbar-collapse" id="navbarColor03">
                <ul class="navbar-nav ml-auto">
                    <li class="nav-item">
                        <a class="nav-link" href="@Url.Action("Index", "StudentComplains")">Dashboard</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="@Url.Action("Create", "StudentComplains")">Create Complains</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="@Url.Action("Index", "StudentAllUsers")">Profile</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="@Url.Action("Logout", "Home")">Logout</a>
                    </li>
                </ul>
            </div>
        </div>
    </nav>

    <div class="container mt-4 mb-5">
        @RenderBody()
    </div>

    <footer class="footer fixed-bottom bg-light py-2">
        <div class="container">
            <p class="m-0 text-center">© 2023 Lab Maintenance Website. All Rights Reserved by Group 9.</p>
        </div>
    </footer>

    @Scripts.Render("~/bundles/jquery")
    @Scripts.Render("~/bundles/bootstrap-js") <!-- Include Bootstrap JavaScript -->
    <script>
        $(document).ready(function () {
            $('.navbar-toggler').click(function () {
                $('.navbar-collapse').toggleClass('show');
            });
        });
    </script>
    @RenderSection("scripts", required: false)
</body>
</html>

Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html>
<head>
    @RenderSection("Styles", required: false)
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>@ViewBag.Title - Lab Maintainer</title>
    @Styles.Render("~/Content/css")
    @Scripts.Render("~/bundles/modernizr")
    @Styles.Render("~/Content/bootstrap-css") <!-- Include Bootstrap CSS -->
    <style>
        .navbar-nav.ml-auto {
            margin-left: auto;
        }
    </style>
</head>
<body>
    <nav class="navbar navbar-expand-lg navbar-light bg-light">
        <div class="container-fluid">
            <a class="navbar-brand" href="#">Lab Maintainer</a>
            <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarColor03" aria-controls="navbarColor03" aria-expanded="false" aria-label="Toggle navigation">
                <span class="navbar-toggler-icon"></span>
            </button>
            <div class="collapse navbar-collapse" id="navbarColor03">
                <ul class="navbar-nav ml-auto">
                    <li class="nav-item">
                        <a class="nav-link" href="@Url.Action("Index", "Complains")">Dashboard</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="@Url.Action("Create", "Complains")">Create Complains</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="@Url.Action("Index", "Tech2")">Actions</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="@Url.Action("Index", "AllUsers")">Profile</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="@Url.Action("Logout", "Home")">Logout</a>
                    </li>
                </ul>
            </div>
        </div>
    </nav>

    <div class="container mt-4 mb-5">
        @RenderBody()
    </div>

    <footer class="footer fixed-bottom bg-light py-2">
        <div class="container">
            <p class="m-0 text-center">© 2023 Lab Maintenance Website. All Rights Reserved by Group 9.</p>
        </div>
    </footer>

    @Scripts.Render("~/bundles/jquery")
    @Scripts.Render("~/bundles/bootstrap-js") <!-- Include Bootstrap JavaScript -->
    <script>
        $(document).ready(function () {
            $('.navbar-toggler').click(function () {
                $('.navbar-collapse').toggleClass('show');
            });
        });
    </script>
    @RenderSection("scripts", required: false)
</body>
</html>

Views/Shared/stuff_layout.cshtml
<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>@ViewBag.Title - Lab Maintainer</title>
    @Styles.Render("~/Content/css")
    @Scripts.Render("~/bundles/modernizr")
    @Styles.Render("~/Content/bootstrap-css") <!-- Include Bootstrap CSS -->
    <style>
        .navbar-nav.ml-auto {
            margin-left: auto;
        }
    </style>
</head>
<body>
    <nav class="navbar navbar-expand-lg navbar-light bg-light">
        <div class="container-fluid">
            <a class="navbar-brand" href="#">Lab Maintainer</a>
            <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarColor03" aria-controls="navbarColor03" aria-expanded="false" aria-label="Toggle navigation">
                <span class="navbar-toggler-icon"></span>
            </button>
            <div class="collapse navbar-collapse" id="navbarColor03">
                <ul class="navbar-nav ml-auto">
                    <li class="nav-item">
                        <a class="nav-link" href="@Url.Action("Index", "StuffComplains")">Dashboard</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="@Url.Action("Create", "StuffComplains")">Create Complains</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="@Url.Action("Index", "Stufftech2")">Actions</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="@Url.Action("Index", "StuffAllUsers")">Profile</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="@Url.Action("Logout", "Home")">Logout</a>
                    </li>
                </ul>
            </div>
        </div>
    </nav>

    <div class="container mt-4 mb-5">
        @RenderBody()
    </div>

    <footer class="footer fixed-bottom bg-light py-2">
        <div class="container">
            <p class="m-0 text-center">© 2023 Lab Maintenance Website. All Rights Reserved by Group 9.</p>
        </div>
    </footer>

    @Scripts.Render("~/bundles/jquery")
    @Scripts.Render("~/bundles/bootstrap-js") <!-- Include Bootstrap JavaScript -->
    <script>
        $(document).ready(function () {
            $('.navbar-toggler').click(function () {
                $('.navbar-collapse').toggleClass('show');
            });
        });
    </script>
    @RenderSection("scripts", required: false)
</body>
</html>